% 50jed-extra.sl: Initialization of jed-extra package

% Copyright (c) 2005 Debian JED Group
%  Released under the terms of the GNU General Public License (v. 2 or later)

% Location of the jed-extra package's library dir
$1 = "/usr/share/jed/jed-extra/";

% if jed-extra is removed (not purged), this file (and possibly the
% jed-extra library dir) exist, but nothing else it expects --> abort
$2 = path_concat($1, "libdir.sl");
#if (file_status($2) != 1)
#stop
#endif

% Add (and initialize) library directories
% ----------------------------------------

require("libdir", $2);

% Utilities (required by the other modes)
% append_libdir($1 + "utils/", 1);    % append and initialize
append_libdir($1 + "utils/", 0);  % append but do not initialize

% "Normal" modes
append_libdir($1, 1);   	    % append and initialize
% append_libdir($1, 0);             % append but do not initialize

% Drop-In Modes (recent, help, man, ...) need to be prepended
% (comment out if you want to keep the original behaviour)
add_libdir($1 + "drop-in/", 1);     % append and initialize
% add_libdir($1 + "drop-in/", 0);   % append but do not initialize

% Experimental and exotic modes
% (uncomment to initalize, maybe better on a per user basis in ~/jed.rc)
% append_libdir($1 + "extra/", 0);  % append but do not initialize
% append_libdir($1 + "extra/", 1);  % append and initialize


% "Manual" initialization of stuff not handled by the ini.sl files
% ----------------------------------------------------------------

% add some autoloads
autoload("push_defaults", "sl_utils");    % needed by ispell_init.sl, complete, occur, ...
autoload("string_nth_match", "strutils"); % needed by hyperman.sl
autoload("get_keystring", "strutils");    % needed by snake.sl
% alternatively evaluate the utils/ini.sl file (or set the "initialize"
% argument to 1 in append_libdir($1 + "utils/", 1) above)
% () = evalfile("utils/ini.sl");          % autoloads for all utilit functions

% Set modes for known filename extensions
add_mode_for_extension ("css1", "css");
add_mode_for_extension ("css1", "css1");
add_mode_for_extension ("gnuplot", "gnuplot");  % gnuplot plotting program
add_mode_for_extension ("gnuplot", "gp");
foreach (["man", "1", "2", "3", "4", "5", "6", "7", "8"]) {
  $2 = ();
  add_mode_for_extension ("manedit", $2);
}
add_mode_for_extension ("mupad", "mu"); % mode for mupad files
add_mode_for_extension ("ruby", "rb");
add_mode_for_extension ("sql", "sql");

% Globally activate extensions
% ----------------------------

% If there are several JED users on the machine, better do this activation in
% the user's jed.rc files, as there is no way a "normal" user can revert
% the choices short of disabling all of the Debian configuration  with
% `jed --skip-debian-startup`.

% require("numbuf");       % number buffers for fast switching
% require("navigate");     % history feature (recent buffers)
% require("ispell_init");  % ispell|aspell support

% require("cuamark");      % use CUA style kind of selecting regions

% Printing
% --------

% there are 2 alternative functions to send the current buffer to a printer
%
% autoload("print_buffer", "print");   % simple, sends pure ASCII
% autoload("print_buffer", "apsmode"); % uses a2ps, needs to be configured
%
% define print_popup_hook (menubar)
% {
%   menu_insert_separator (6, "Global.&File");
%   menu_insert_item (7, "Global.&File", "&Print Buffer", "print_buffer");
% }
% append_to_hook ("load_popup_hooks", &print_popup_hook);
